import 'package:example/state/state.dart';
import 'package:osam/domain/event/event.dart';
import 'package:osam/domain/middleware/middleware.dart';
import 'package:osam/domain/store/store.dart';

class MyMiddleware extends Middleware<Store<AppState>> {
  final int number;

  MyMiddleware(this.number);

  bool isIncrement(Event event) {
    if (event is IncrementEvent) {
      Future.delayed(Duration(seconds: 1), () {
        print('hello from middlewar $number');
      });
      return nextEvent(true);
    } else {
      store.updateMiddleware(MyMiddleware(1));
      return nextEvent(false);
    }
  }

  @override
  List<Condition> get conditions => [isIncrement];
}

class IncrementEvent extends ModificationEvent<AppState, int> {
  IncrementEvent({int bundle});

  @override
  get reducer => (AppState state, int bundle) => state..increment();
}
